<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <style>
        *{
            font-size: 1.3rem;
        }
        pre{
            background: silver;

        }
        .green{
            color: green;
        }
        li:nth-child(odd){
         background: #e1e6e5;
         margin: 1rem 0;
        }
    </style>
    <script>
        window.addEventListener("load",()=>{
            document.getElementsByTagName("ol")[0].addEventListener("dblclick", (e)=>{
                e.target.style.backgroundColor = "green"
                e.target.style.opacity = ".3"
                e.target.style.fontSize = ".8rem"
            })
        const arr = new Array(50);

        arr.forEach((e,i,a)=>{
           arr[i] = 5
        })
        
        })
    </script>
</head>
<body>
   <ol>
       <li>Дані два масиви: ['a', 'b', 'c'] та [1, 2, 3]. Об'єднайте їх разом.</li>

       <script>
            var arr1 = ['a', 'b', 'c'];
            var arr2 = [1, 2, 3];
            document.write('1. Array.prototype.concat() <br>');
            var summary = [].concat(arr1,arr2);
        //  var summary = arr1.concat(arr2); //same result        
        </script>
        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    var arr2 = [1, 2, 3];
                    var summary = [].concat(arr1,arr2);
                //  var summary = arr1.concat(arr2); //same result</span> 
            </code>
        </pre>
        <script>
            document.write(`Summary by Concat = ${summary}<br><br>`);
        </script>

        <script>
            var arr1 = ['a', 'b', 'c'];
            var arr2 = [1, 2, 3];
            document.write('2. Spread <br>');
            var summary = [...arr1, ...arr2];
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    var arr2 = [1, 2, 3];
                    var summary = [...arr1, ...arr2];</span> 
            </code>
        </pre>
        <script>
            document.write(`Summary by Spread = ${summary}<br><br>`);
        </script>

        <script>
            var arr1 = ['a', 'b', 'c'];
            var arr2 = [1, 2, 3];
            document.write('3. Array.prototype.push() + Spread if we shouldnt create any new arrays for result of merging arr1 and arr2 <br>');
            arr1.push(...arr2);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    var arr2 = [1, 2, 3];
                    arr1.push(...arr2);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 by Push + Spread = ${arr1}<br><br>`);
        </script>

        <script>
            var arr1 = ['a', 'b', 'c'];
            var arr2 = [1, 2, 3];
            document.write('4. Array.prototype.splice() + Spread if we shouldnt create any new arrays for result of merging arr1 and arr2 <br>');
            arr1.splice(3, 0, ...arr2)
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    var arr2 = [1, 2, 3];
                    arr1.splice(3, 0, ...arr2);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 by Splice + Spread = ${arr1}<br><br>`);
        </script>

       <li>Дан масив ['a', 'b', 'c']. Додайте йому до кінця елементи 1, 2, 3.</li>
        
        <script>
            var arr1 = ['a', 'b', 'c'];
            document.write('<br> 1. Array.prototype.push() <br>');
            arr1.push(1, 2, 3);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    arr1.push(1, 2, 3);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 modified by Push = ${arr1}<br><br>`);
        </script>

        <script>
            var arr1 = ['a', 'b', 'c'];
            document.write('<br> 2. Array.prototype.splice() <br>');
            arr1.splice(3, 0, 1, 2, 3);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['a', 'b', 'c'];
                    arr1.splice(3, 0, 1, 2, 3);</span> 
                </code>
        </pre>
        <script>
            document.write(`arr1 modified by Splice = ${arr1}<br><br>`);
        </script>

       <li>Дан масив [1, 2, 3]. Зробіть із нього масив [3, 2, 1].</li>

       <script>
            var arr1 = ['1', '2', '3'];
            document.write('<br> 1. Array.prototype.reverse() <br>');
            arr1.reverse();
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['1', '2', '3'];
                    arr1.reverse();</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 modified by Reverse = ${arr1}<br><br>`);
        </script>

       <li>Дан масив [1, 2, 3]. Додайте йому до кінця елементи 4, 5, 6.</li>
      
        <script>
            var arr1 = [1, 2, 3];
            document.write('<br> 1. Array.prototype.push() <br>');
            arr1.push(4, 5, 6);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3];
                    arr1.push(4, 5, 6);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 modified by Push = ${arr1}<br><br>`);
        </script>

        <script>
            var arr1 = [1, 2, 3];
            document.write('<br> 2. Array.prototype.splice() <br>');
            arr1.splice(3, 0, 4, 5, 6);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3];
                    arr1.splice(3, 0, 4, 5, 6);</span> 
                </code>
        </pre>
        <script>
            document.write(`arr1 modified by Splice = ${arr1}<br><br>`);
        </script>

       <li>Дан масив [1, 2, 3]. Додайте йому на початок елементи 4, 5, 6.</li>

       <script>
            var arr1 = [1, 2, 3];
            document.write('<br> 1. Array.prototype.splice() <br>');
            arr1.splice(0, 0, 4, 5, 6);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3];
                    arr1.splice(0, 0, 4, 5, 6);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 modified by Splice = ${arr1}<br><br>`);
        </script>

        <script>
            var arr1 = [1, 2, 3];
            document.write('<br> 2. Array.prototype.unshift() <br>');
            arr1.unshift(4, 5, 6);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3];
                    arr1.unshift(4, 5, 6);</span> 
            </code>
        </pre>
        <script>
            document.write(`arr1 modified by Unshift = ${arr1}<br><br>`);
        </script>

        <li>Дан масив ['js', 'css', 'jq']. Виведіть перший елемент на екран.</li>
       
        <script>
            var arr1 = ['js', 'css', 'jq'];
            document.write(`simple document.write first element by index arr1[0], result = ${arr1[0]}<br><br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['js', 'css', 'jq'];
                    document.write(arr1[0]);</span> 
            </code>
        </pre>


       <li>Дан масив [1, 2, 3, 4, 5]. За допомогою методу slice запишіть нові елементи [1, 2, 3].</li>

       <script>
        var arr1 = [1, 2, 3, 4, 5];
        document.write(`<br>Shadow copy of first three elements by using Array.prototype.slice() method, result = ${arr1.slice(0, 3)}<br><br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3, 4, 5];
                    document.write(arr1.slice(0, 3));</span> 
            </code>
        </pre>

       <li>Дан масив [1, 2, 3, 4, 5]. За допомогою методу splice перетворіть масив на [1, 4, 5].</li>

       <script>
            var arr1 = [1, 2, 3, 4, 5];
            arr1.splice(1, 2);
            document.write(`<br> Array.prototype.splice() to arr, result = ${arr1}<br><br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3, 4, 5];
                    arr1.splice(2, 1);</span> 
            </code>
        </pre>


       <li>Дан масив [1, 2, 3, 4, 5]. За допомогою методу splice перетворіть масив на [1, 2, 10, 3, 4, 5].</li>

       <script>
            var arr1 = [1, 2, 3, 4, 5];
            arr1.splice(2, 0, 10);
            document.write(`<br> Array.prototype.splice() to arr1, result = ${arr1}<br><br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [1, 2, 3, 4, 5];
                    arr1.splice(2, 10);</span> 
            </code>
        </pre>


       <li>Дан масив [3, 4, 1, 2, 7]. Відсортуйте його.</li>

       <script>
            var arr1 = [3, 4, 1, 2, 7];
            arr1.sort();
            document.write(`<br> Array.prototype.sort() to arr1, result = ${arr1}<br><br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = [3, 4, 1, 2, 7];
                    arr1.sort();</span> 
            </code>
        </pre>

       <li>Дан масив з елементами 'Привіт, ', 'світ' і '!'. Потрібно вивести на екран фразу 'Привіт, мир!'.</li>

       <script>
            var arr1 = ['Привіт, ', 'світ', '!'];
            arr1.splice(1, 1, 'мир');
            document.write(`<br> Array.prototype.splice() + Array.prototype.join() to arr1, result = ${arr1.join('')}<br><br>`);

        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['Привіт, ', 'світ', '!'];
                    arr1.splice(1, 1, 'мир');
                    document.write(arr1.join('')); 
            </code>
        </pre>

       <li>Дан масив ['Привіт, ', 'світ', '!']. Необхідно записати в нульовий елемент цього масиву слово 'Поки, ' (тобто замість слова 'Привіт, ' буде 'Поки, ').</li>

       <script>
        var arr1 = ['Привіт, ', 'світ', '!'];
        arr1.splice(0, 1, 'Поки, ');
        document.write(`<br> Array.prototype.splice() to arr1, result = ['${arr1[0]}','${arr1[1]}','${arr1[2]}']<br><br>`);

        </script>

        <pre>
            <code>
                <span class="green">
                    var arr1 = ['Привіт, ', 'світ', '!'];
                    arr1.splice(0, 1, 'Поки, ');
            </code>
        </pre>

       <li>Створіть масив arr з елементами 1, 2, 3, 4, 5 двома різними способами.</li>

        <script>
            var arr = [1, 2, 3, 4, 5,];
            document.write(`<br> 1. creating by syntax [], result = [${arr}]<br>`);
            var arr = new Array (1, 2, 3, 4, 5,); 
        //  var arr = Array (1, 2, 3, 4, 5,); //same result
            document.write(`<br> 2. creating by constructor Array(), result = [${arr}]<br>`);

    
        </script>
    
        <pre>
            <code>
                <span class="green">
                    var arr = [1, 2, 3, 4, 5,];
                    var arr = new Array (1, 2, 3, 4, 5,); 
                //  var arr = Array (1, 2, 3, 4, 5,); //same result
            </code>
        </pre>

       <li>Дан багатовимірний масив arr:
        <pre>
            <code>
                var arr = {
                    'ru':['блакитний', 'червоний', 'зелений'],
                    'en':['blue', 'red', 'green'],
                };
            </code>
        </pre>
        Виведіть за його допомогою слово 'блакитний' 'blue'.
        <br>
        <script>
            var arr = [['блакитний', 'червоний', 'зелений'], ['blue', 'red', 'green']];
            document.write(`<br>for блакитний, result = '${arr[0][0]}'<br>`);
            document.write(`<br>for blue, result = '${arr[1][0]}'<br>`);
        </script>
    
        <pre>
            <code>
                <span class="green">
                    var arr = [['блакитний', 'червоний', 'зелений'], ['blue', 'red', 'green']];
                    document.write(arr[0][0]); // for 'блакитний'
                    document.write(arr[1][0]); // for 'blue'
            </code>
        </pre>
        </li>
       <li>Створіть масив arr = ['a', 'b', 'c', 'd'] і за допомогою його виведіть на екран рядок 'a+b, c+d'.</li>

       <script>
            var arr = ['a', 'b', 'c', 'd'];
            document.write(`<br>Array.prototype.slice() + Array.prototype.join() for arr, result = '${arr.slice(0, 2).join('+')}, ${arr.slice(2, 4).join('+')}'<br>`);
        </script>

        <pre>
            <code>
                <span class="green">
                    var arr = ['a', 'b', 'c', 'd'];
                    document.write(arr.slice(0, 2).join('+')+ ', ' + arr.slice(2, 4).join('+'));</span> 
            </code>
        </pre>

       <li>
        Запитайте у користувача кількість елементів масиву. Виходячи з даних, які ввів користувач
        створіть масив на ту кількість елементів, яку передав користувач.
        у кожному індексі масиву зберігайте чило який показуватиме номер елемента масиву.

        <script>
            var itemCount = parseInt(prompt("Set a number of array elements"));
            var arr = [];
            for (let i = 0; i < itemCount; i++) {
                arr.push(i);                
            }
        </script>

        <pre>
            <code>
                <span class="green">
                    var itemCount = parseInt(prompt("Set a number of array elements"));
                    var arr = [];
                    for (let i = 0; i < itemCount; i++) {
                        arr.push(i);                
                    }</span>
            </code>
        </pre>

       </li>
       <li>Зробіть так, щоб з масиву, який ви створили вище, вивелися всі непарні числа в параграфі, а парні в спані з червоним тлом.</li>

       <script>
            for (let i = 0; i < arr.length; i++) {
                if (arr[i] % 2 === 0) {
                    document.write(`<p>${i}</p>`)
                }else
                document.write(`<span style="background-color:red">${i}</span>`)
            }
        </script>

        <pre>
            <code>
                <span class="green">
                    for (let i = 0; i < arr.length; i++) {
                        if (arr[i] % 2 === 0) {
                          document.write(`${i}`) // + wrapped by p
                        }else
                        document.write(`${i}`) // +wrapped by span tag with background-color style
                    }
                    have no idea how is it possible to block code execution
                    in code tag in html, right code is inside html</span>
            </code>
        </pre>

       <li>Напишіть код, який перетворює та об'єднує всі елементи масиву в одне рядкове значення. Елементи масиву будуть розділені комою.
           <pre>
               <code>
                var vegetables = ['Капуста', 'Ріпа', 'Редиска', 'Морковка'];
    
                <span class="green">
                    var vegetables = ['Капуста', 'Ріпа', 'Редиска', 'Морковка'];
                    var str1 = '';
                    vegetables.splice(3, 1, 'Морквина');
                    str1 = vegetables.join(', ') // if spaces are needed in string
                //  str1 = vegetables.join(',') // if no spaces are needed in string
                //  str1 = vegetables.toString() // if no spaces are needed in string</span>

                
                document.write(str1); // "Капуста, Ріпа, Редиска, Морквина"
               </code>
           </pre>
        <script>
            var vegetables = ['Капуста', 'Ріпа', 'Редиска', 'Морковка'];
            var str1 = '';
            vegetables.splice(3, 1, 'Морквина');
            str1 = vegetables.join(', ') // if spaces are needed in string
        //  str1 = vegetables.join(',') // if no spaces are needed in string
        //  str1 = vegetables.toString() // if no spaces are needed in string
          document.write(str1)
        </script>


       </li>
   </ol>

</body>
</html>
